Backport191 - Backport #2568

Segmentation fault deleting key nhamed :class via Hash#delete defined via define_method

01/07/2010 09:48 AM - kch (Caio Chassot)

Status: Closed

Priority: Normal

Assignee: yugui (Yuki Sonoda)
Description

=begin

$ cat bughash.rb
#!/usr/bin/env ruby1.9

class BugHash < Hash
define_method(:delete) { |*a| super *a }
end

BugHash.new.delete :class

$ ruby1.9 bughash.rb
bughash.rb:4: [BUG] Segmentation fault
ruby 1.9.1p376 (2009-12-07 revision 2604 1) [i386-darwin10]

-- control frame ----------

€:0006 p:---- s:0015 b:0015 1:000014 d:000014 CFUNC :delete

€:0005 p:0011 s:0011 b:0011 1:0022c8 d:000010 LAMBDA bughash.rb:4
€:0004 p:---- s:0008 b:0008 1:000007 d:000007 FINISH

€:0003 p:0039 s:0006 b:0006 1:001a68 d:000c88 EVAL bughash.rb:7
€:0002 p:---- s:0004 b:0004 1:000003 d:000003 FINISH

€:0001 p:0000 s:0002 b:0002 1:001a68 d:001a68 TOP

-- Ruby level backtrace information
bughash.rb:4:in delete'
bughash.rb:4:inblock in class:BugHash'
bughash.rb:7:in ™'

-- C level backtrace information

[NOTE]
You may encounter a bug of Ruby interpreter. Bug reports are welcome.
For details: http://www.ruby-lang.org/bugreport.html

Abort trap
=end

Related issues:
Related to Ruby master - Bug #2583: [I00000 defined? yield 0 "yield" 00[ Closed

01/10/2010

History

#1 - 01/12/2010 09:19 PM - wanabe (_ wanabe)

=begin
backporting r26283 will fix this issue, | guess.
=end

#2 - 01/13/2010 08:11 AM - nobu (Nobuyoshi Nakada)
- Category set to core
- Status changed from Open to Assigned

- Assignee set to yugui (Yuki Sonoda)

=begin
=end

#3 - 07/15/2019 07:08 PM - jeremyevans0 (Jeremy Evans)
- Status changed from Assigned to Closed

- Description updated
